SystemOrganization addCategory: #SpyServer!

WAComponent subclass: #SpyLogListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SpyServer'!

!SpyLogListView class methodsFor: 'as yet unclassified' stamp: 'dgg 1/6/2012 00:37'!
initialize
	 WAAdmin register: self asApplicationAt: 'listview'! !

!SpyLogListView methodsFor: 'as yet unclassified' stamp: 'dgg 1/25/2012 13:06'!
renderContentOn: html
	html heading level: 1; with: 'Uploaded logs'.
	html table: [
		SpyLogRegister register logs do: [:each |
			html tableRow: [
				html tableHeading: each fileName asString.
				html tableData: each date asString.
				html tableData: each language asString.
				html tableData with: [(html anchor
					callback: [self viewSpyLog: each];
					with: 'view')]]] ]! !

!SpyLogListView methodsFor: 'as yet unclassified' stamp: 'dgg 1/25/2012 13:02'!
viewSpyLog: aSpyLog
	self call: (
		SmalltalkSpyLogView new
			 spylog: aSpyLog;
			yourself)! !

WAComponent subclass: #SpyLogView
	instanceVariableNames: 'spylog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SpyServer'!

SpyLogView subclass: #SmalltalkSpyLogView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SpyServer'!

!SmalltalkSpyLogView methodsFor: 'as yet unclassified' stamp: 'dgg 1/25/2012 12:59'!
renderContentOn: html
	| xml dict |
	xml := self getSpyLogAsXML.
	dict := Dictionary new.
	xml root nodes do: [:each |
		dict at: each name asSymbol
			 ifPresent: [:col | col add: each]
			 ifAbsent: [dict at: each name asSymbol put: (OrderedCollection with: each)]].
	html table: [
		dict keysAndValuesDo: [:key :value |
			html tableRow: [
				html tableHeading: key.
				html tableData: 'events #: ',value size asString]] ]
	! !

!SpyLogView methodsFor: 'as yet unclassified' stamp: 'dgg 1/25/2012 13:06'!
getSpyLogAsXML
	^ SpyFileDirectory getSpyLogAsXML: (self spylog)! !

!SpyLogView methodsFor: 'as yet unclassified' stamp: 'dgg 1/25/2012 12:49'!
spylog
	^ spylog! !

!SpyLogView methodsFor: 'as yet unclassified' stamp: 'dgg 1/25/2012 12:56'!
spylog: aSpylog
	spylog := aSpylog.! !

WAComponent subclass: #UploadForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SpyServer'!

!UploadForm methodsFor: 'as yet unclassified' stamp: 'dgg 1/2/2012 18:02'!
receiveFile: aFile
	| stream |
	stream := (FileDirectory default directoryNamed: 'uploads')
		assureExistence;
		forceNewFileNamed: aFile fileName.
	[ 
	stream
		binary;
		nextPutAll: aFile rawContents ]
		ensure: [ stream close ]! !

!UploadForm methodsFor: 'as yet unclassified' stamp: 'dgg 1/4/2012 22:49'!
receiveFile: aFile data:  data
	| stream user |
	user := data at: #username ifAbsent: [''].
	stream := ((FileDirectory default directoryNamed: 'uploads') / (user asString))
		assureExistence;
		forceNewFileNamed: aFile fileName.
	[ 
	stream
		binary;
		nextPutAll: aFile rawContents ]
		ensure: [ stream close ]! !

!UploadForm methodsFor: 'as yet unclassified' stamp: 'dgg 1/4/2012 22:38'!
registerNewSpyLogFrom: data
	| spyLog |
	spyLog := SpyLog new.
	 ! !

!UploadForm methodsFor: 'as yet unclassified' stamp: 'dgg 1/2/2012 18:01'!
renderContentOn: html
	html form multipart; with: [
		html fileUpload
			callback: [:value | self receiveFile: value].
		html submitButton: 'send file' ]! !

WARestfulHandler subclass: #UploadHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SpyServer'!

!UploadHandler class methodsFor: 'as yet unclassified' stamp: 'dgg 1/2/2012 18:41'!
initialize
	 WAAdmin register: self at: 'upload-api'! !

!UploadHandler methodsFor: 'as yet unclassified' stamp: 'dgg 5/21/2012 04:19'!
test
	<get>
	^'OK' asByteArray.! !

!UploadHandler methodsFor: 'as yet unclassified' stamp: 'dgg 5/20/2012 17:27'!
upload
	<post>
	<consumes: 'multipart/form-data'>
	| file md5 post log |
	file := self requestContext request postFields at: 'file'.	"<consumes: 'multipart/form-data'>"	"	self requestContext explore.
	self requestContext request explore."
	md5 := MD5 new hashStream: file rawContents readStream.
	post := self requestContext request postFields.
	md5 = (self requestContext request postFields at: 'md5') asByteArray
		ifTrue: [ 
			| data |
			data := Dictionary new.
			data at: #md5 put: md5.
			data at: #author put: (post at: 'author').
			data at: #language put: (post at: 'language').
			data at: #dump put: (post at: 'dump' ifAbsent: [nil] ).
			log := SpyFileDirectory storeFile: file with: data.
			SpyLogRegister register add: log.
			^ 'OK' asByteArray ]
		ifFalse: [ ^ 'bad md5 sum' asByteArray ]! !

Object subclass: #SpyFileDirectory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SpyServer'!

!SpyFileDirectory class methodsFor: 'as yet unclassified' stamp: 'dgg 1/18/2012 18:37'!
defaultUploadPathFor: aSpyLog
	| delimiter |
	delimiter := FileDirectory default pathNameDelimiter asString.
	^'uploads', delimiter, aSpyLog language, delimiter, aSpyLog date year asString, delimiter, aSpyLog date month asString, delimiter, aSpyLog author.! !

!SpyFileDirectory class methodsFor: 'as yet unclassified' stamp: 'dgg 1/25/2012 11:54'!
getSpyLogAsXML: aSpyLog
	| delimiter path |
	delimiter := FileDirectory default pathNameDelimiter asString.
	path := (self defaultUploadPathFor: aSpyLog), delimiter, aSpyLog fileName.
	^ self getSpyLogFileAsXML: path.! !

!SpyFileDirectory class methodsFor: 'as yet unclassified' stamp: 'dgg 5/20/2012 18:15'!
getSpyLogFileAsXML: aFileNamePath
	| unzipped xml |
	unzipped := MultiByteBinaryOrTextStream with: ((GZipReadStream on: (FileStream readOnlyFileNamed: aFileNamePath)) contents asString).
	unzipped reset.
	xml := XMLDOMParser on: unzipped.
	^ xml parseDocument.! !

!SpyFileDirectory class methodsFor: 'as yet unclassified' stamp: 'dgg 1/18/2012 18:34'!
getSpyLogFor: aFile with: fileMetaData
	^ (SpyLog new)
		author: (fileMetaData at: #author ifAbsent: [ '' ]);
		date: DateAndTime now;
		md5sum: (fileMetaData at: #md5 ifAbsent: [ '' ]);
		language: (fileMetaData at: #language ifAbsent: [ '' ]);
		fileName: aFile fileName;
		yourself.! !

!SpyFileDirectory class methodsFor: 'as yet unclassified' stamp: 'dgg 5/20/2012 17:21'!
storeFile: aFile with: fileMetaData
	| stream log |
	log := self getSpyLogFor: aFile with: fileMetaData.
	stream := (FileDirectory default directoryNamed: (self defaultUploadPathFor: log))
		assureExistence;
		forceNewFileNamed: aFile fileName.
	[ 
	stream
		binary;
		nextPutAll: aFile rawContents ]
		ensure: [ stream close ].
	^ log! !

Object subclass: #SpyLog
	instanceVariableNames: 'md5sum language date author fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SpyServer'!

!SpyLog class methodsFor: 'as yet unclassified' stamp: 'dgg 1/18/2012 18:33'!
newFor: aFile author: author
	^ (self new)
		date: DateAndTime now;
		author: author;
		fileName: aFile fileName;
		yourself.! !

!SpyLog methodsFor: 'accessing' stamp: 'dgg 1/4/2012 20:32'!
author
	^ author! !

!SpyLog methodsFor: 'accessing' stamp: 'dgg 1/4/2012 20:32'!
author: anObject
	author := anObject! !

!SpyLog methodsFor: 'accessing' stamp: 'dgg 1/4/2012 20:32'!
date
	^ date! !

!SpyLog methodsFor: 'accessing' stamp: 'dgg 1/4/2012 20:32'!
date: anObject
	date := anObject! !

!SpyLog methodsFor: 'accessing' stamp: 'dgg 1/5/2012 00:46'!
fileName
	^ fileName! !

!SpyLog methodsFor: 'accessing' stamp: 'dgg 1/5/2012 00:46'!
fileName: anObject
	fileName := anObject! !

!SpyLog methodsFor: 'accessing' stamp: 'dgg 1/18/2012 18:35'!
language
	^ language! !

!SpyLog methodsFor: 'accessing' stamp: 'dgg 1/18/2012 18:35'!
language: anObject
	language := anObject! !

!SpyLog methodsFor: 'accessing' stamp: 'dgg 1/4/2012 20:32'!
md5sum
	^ md5sum! !

!SpyLog methodsFor: 'accessing' stamp: 'dgg 1/4/2012 20:32'!
md5sum: anObject
	md5sum := anObject! !

Object subclass: #SpyLogDB
	instanceVariableNames: 'session'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'SpyServer'!

!SpyLogDB class methodsFor: 'as yet unclassified' stamp: 'dgg 1/4/2012 21:23'!
commit: aBlock
	self uniqueInstance session commit: aBlock.! !

!SpyLogDB class methodsFor: 'as yet unclassified' stamp: 'dgg 5/20/2012 16:08'!
createDB
	(FileDirectory default directoryExists: self path) not | self path asMagmaLocalLocation isMagmaRepository not
		ifTrue: [ MagmaRepositoryController create: self path root: SpyLogRegister default ]! !

!SpyLogDB class methodsFor: 'as yet unclassified' stamp: 'dgg 1/5/2012 01:36'!
path
	^'spylogdb'! !

!SpyLogDB class methodsFor: 'as yet unclassified' stamp: 'dgg 1/5/2012 01:35'!
release
	Default isNil ifFalse: [
		Default session disconnectAndClose.
		Default :=  nil]! !

!SpyLogDB class methodsFor: 'as yet unclassified' stamp: 'dgg 1/4/2012 21:22'!
root
	^ self uniqueInstance session root! !

!SpyLogDB class methodsFor: 'as yet unclassified' stamp: 'dgg 1/4/2012 21:21'!
uniqueInstance
	^ Default ifNil: [Default := self new connect; yourself]! !

!SpyLogDB methodsFor: 'as yet unclassified' stamp: 'dgg 1/4/2012 21:20'!
connect
	session := (MagmaSession openLocal: self class path)
		connectAs: 'user'! !

!SpyLogDB methodsFor: 'as yet unclassified' stamp: 'dgg 1/4/2012 21:19'!
session
	^session ! !

Object subclass: #SpyLogRegister
	instanceVariableNames: 'logs'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'SpyServer'!

!SpyLogRegister class methodsFor: 'as yet unclassified' stamp: 'dgg 1/4/2012 21:11'!
default
	^ Default ifNil: [Default := self new]! !

!SpyLogRegister class methodsFor: 'as yet unclassified' stamp: 'dgg 1/5/2012 21:56'!
register
	^ SpyLogDB root! !

!SpyLogRegister class methodsFor: 'as yet unclassified' stamp: 'dgg 1/4/2012 21:11'!
reset
	Default := nil! !

!SpyLogRegister methodsFor: 'as yet unclassified' stamp: 'dgg 5/20/2012 17:13'!
add: aSpyLog
	SpyLogDB
		commit: [ 
			(self verifyUniqueLog: aSpyLog)
				ifTrue: [ self logs add: aSpyLog ] ]! !

!SpyLogRegister methodsFor: 'as yet unclassified' stamp: 'dgg 1/4/2012 20:39'!
initialize
	super initialize.
	self logs: OrderedCollection new.! !

!SpyLogRegister methodsFor: 'as yet unclassified' stamp: 'dgg 1/4/2012 20:39'!
logs
	^ logs! !

!SpyLogRegister methodsFor: 'as yet unclassified' stamp: 'dgg 1/4/2012 20:39'!
logs: aCollection
	logs := aCollection! !

!SpyLogRegister methodsFor: 'as yet unclassified' stamp: 'dgg 5/20/2012 17:16'!
remove: aSpyLog
	SpyLogDB commit: [ self logs remove: aSpyLog ]! !

!SpyLogRegister methodsFor: 'as yet unclassified' stamp: 'dgg 1/5/2012 01:33'!
verifyUniqueLog: aSpyLog
	^ (self logs anySatisfy: [:log | log md5sum = aSpyLog md5sum]) not! !
SpyLogListView initialize!
UploadHandler initialize!
